#include <iostream>

#include "../../helpers/println.hpp"
#include <iostream>

struct PascalString{
	int length;            // number of chars used
	char characters[256];  // chars of some character string
};

void printPascalString(PascalString string) {
    for(char c : string.characters)
        print(c);
    println("");
}

int lengthOfInt(int i) {
    if(i < 8) return 1;
    return 1 + lengthOfInt(i / 8);
}


PascalString intToOctal(int value) {
    int i = lengthOfInt(value) + 1;
    PascalString result = {i};
    while(i > 1) {
        result.characters[i] = (value % 8) + '0';
        value = value / 8;
        i--;
    }
    return result;
    
}

PascalString bitwiseDualAnd(PascalString a, PascalString b) {
    PascalString result = {a.length};
    println(result.length);
    for(int i = a.length; i >= 0; --i) {
        int ac = a.characters[i] - '0';
        int bc = b.characters[i] - '0';
        result.characters[i] = (ac & bc) + '0';
    }
    return result;
}

int main(int argc, char** argv, char** envp) {
    println("=============printPascalString===============");
    printPascalString({3, '3', 'f', '1'});
    printPascalString({5, 'H', 'a', 'l', 'l', 'o'});
    println("=============intToOctal===============");
    printPascalString(intToOctal(7));
    printPascalString(intToOctal(565));
    printPascalString(intToOctal(585858));
    println("=============bitwiseDualAnd===============");
    printPascalString(bitwiseDualAnd({2, '0', '1'}, {2, '1', '0'}));
    printPascalString(bitwiseDualAnd({2, '1', '1'}, {2, '1', '1'}));
    printPascalString(bitwiseDualAnd({7, '1', '0', '1', '0', '1', '0', '1'}, {7, '0', '0', '1', '1', '0', '0', '1'}));
  return 0;
}
